//
// JPHP - JIT optimizer for the PHP language
// Copyright (C) 2001-2003 Indrek Mandre <indrek(at)mare.ee>
//
// This source code is made available free and without charge subject
// to the terms of the QPL as detailed in bundled LICENSE.QPL file.
//
// It may be only used for non-commercial purpose.
//

#ifndef __freplace_hh__
#define __freplace_hh__

struct freplace_data
{
  void *function;
#ifdef sparc /* sparc 32 bit */
  char head[8];  /* b and nop */
#else /* i386 */
  char head[5];  /* long jump */
#endif
};

extern int _function_replace (struct freplace_data* store_old, void *function, void *new_function);
extern int _function_restore (struct freplace_data* old);

template<typename T>
inline bool freplace (struct freplace_data* store_old, T function, T new_function)
{
  return _function_replace (store_old, (void *)function, (void *)new_function);
}

inline bool frestore (struct freplace_data* old)
{
  return _function_restore (old);
}

#endif // #ifndef __freplace_hh__

