
//
// JPHP - JIT optimizer for the PHP language
// Copyright (C) 2001-2003 Indrek Mandre <indrek(at)mare.ee>
//
// This source code is made available free and without charge subject
// to the terms of the QPL as detailed in bundled LICENSE.QPL file.
//
// It may be only used for non-commercial purpose.
//

#ifndef __mm_hh__
#define __mm_hh__

struct mem_pool;

class MemMan
{
public:
  MemMan (void *ptr, size_t usize);

  void * alloc (size_t usize);
  void free (void *ptr);
  void * realloc (void *ptr, size_t usize);
  void * calloc (size_t number, size_t usize);
  char * strdup (const char *str);
  size_t size_of (const void *ptr) const;
  size_t available () const;

  ~MemMan ();

private:
  mem_pool *mm;
};

#endif // !__mm_hh__

