
//
// JPHP - JIT optimizer for the PHP language
// Copyright (C) 2001-2003 Indrek Mandre <indrek(at)mare.ee>
//
// This source code is made available free and without charge subject
// to the terms of the QPL as detailed in bundled LICENSE.QPL file.
//
// It may be only used for non-commercial purpose.
//

#ifndef __optimize_hh__
#define __optimize_hh__

class Cell {
public:
  struct brk_cont_str {
    Cell *brk;
    Cell *cont;
    int parent;
  };

  typedef vector<Cell::brk_cont_str> brk_cont_t;

  Cell ();
  Cell (zend_op *op);

  bool resolve_vars (Cell *parent);

  void alt_jmp_to (Cell *to);

  void replace (Cell *c);

  ex_node node;
  Cell *next_jmp;
  Cell *j2_next;

  znode op1;
  znode op2;
  ulong extended_value;

  set<Cell *>jump_from;
  set<Cell *>jump_to;

  int order_id;

private:
  Cell (const Cell&);
  const Cell& operator= (const Cell&);

// Optimization data structures. I wonder how this'll work out. I doubt it'll work out nicely.
// Prolly be a nightmare.

  struct var {
    vstring name;
    bool is_writable;
  };

  bool clears_all_vars;
  set<var> resolved_vars_in;
  set<var> resolved_vars_out;

  vstring op1_var;
  vstring op2_var;
  vstring result_var;
};

#endif // __optimize_hh__

